package org.example.test;

import org.eclipse.jdt.internal.compiler.tool.EclipseCompiler;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.io.TempDir;

import javax.tools.*;
import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.Set;

import static javax.tools.JavaCompiler.CompilationTask;
import static org.junit.jupiter.api.Assertions.assertTrue;

class AutomaticModulesTest {
    @TempDir
    File classOutput;

    @Test
    void reproduceIssue() throws IOException {
        JavaCompiler compiler = new EclipseCompiler();
        //JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
        StandardJavaFileManager standardFileManager = compiler.getStandardFileManager(null, null, null);

        List<File> classPath = List.of(new File("../automatic-module/target/automatic-module-1.0-SNAPSHOT.jar"));
        List<File> sourcePath = List.of(new File("src/test/resources/project"));
        standardFileManager.setLocation(StandardLocation.CLASS_PATH, classPath);
        standardFileManager.setLocation(StandardLocation.MODULE_PATH, classPath);
        standardFileManager.setLocation(StandardLocation.SOURCE_PATH, sourcePath);
        standardFileManager.setLocation(StandardLocation.CLASS_OUTPUT, List.of(classOutput));

        // Make ECJ think we don't inherit StandardJavaFileManager by wrapping it.
        JavaFileManager demotedFileManager = DemotingFileManagerProxy.demote(standardFileManager);
        Iterable<JavaFileObject> compilationUnits = demotedFileManager.list(StandardLocation.SOURCE_PATH, "", Set.of(JavaFileObject.Kind.SOURCE), true);

        CompilationTask task = compiler.getTask(
                null,
                demotedFileManager,
                null,
                List.of("--release", "11", "-verbose"),
                List.of(),
                compilationUnits
        );

        assertTrue(task.call());
    }
}
